#pragma config(Sensor, dgtl11, lClawSol,       sensorDigitalOut)
#pragma config(Sensor, dgtl12, rClawSol,       sensorDigitalOut)
#pragma config(Motor,  port2,           frontLeft,     tmotorVex393TurboSpeed_MC29, openLoop)
#pragma config(Motor,  port3,           frontRight,    tmotorVex393TurboSpeed_MC29, openLoop)
#pragma config(Motor,  port8,           backLeft,      tmotorVex393TurboSpeed_MC29, openLoop)
#pragma config(Motor,  port9,           backRight,     tmotorVex393TurboSpeed_MC29, openLoop)
//*!!Code automatically generated by 'ROBOTC' configuration wizard               !!*//

// This file is part of CHN, and is therefore licensed under the GNU GPLv3 public license.
// Copyright (C) 2016  Ganden Schaffner

/* Controls
	Ch1: Movement - Rotation
	Ch3: Movement - Forward/Backward
	Ch4: Movement - Strafe (in all directions)
	Ch5: Raise or lower the lift
	Ch6D: Toggle the claw open or closed
*/

// This code is for the VEX cortex platform
#pragma platform(VEX2)

// Select Download method as "competition"
#pragma competitionControl(Competition)

//Main competition background code...do not modify!
#include "Vex_Competition_Includes.c"

// Methods
/*! A method to move the bot based on Ch1+Ch3+Ch4 (joystick input)
*/
void moveStick() {
	motor[frontLeft] = vexRT[Ch3] - vexRT[Ch1] - vexRT[Ch4];
	motor[frontRight] = vexRT[Ch3] + vexRT[Ch1] + vexRT[Ch4];
	motor[backLeft] = vexRT[Ch3] - vexRT[Ch1] + vexRT[Ch4];
	motor[backRight] = vexRT[Ch3] + vexRT[Ch1] - vexRT[Ch4];
}

/*! A method to allow control of the bot's claw (pneuamtics).
*/
void clawControl() {
	if(vexRT[Btn6D] == 1) {
		SensorValue[lClawSol] = abs(SensorValue[lClawSol] - 1);
		SensorValue[rClawSol] = abs(SensorValue[rClawSol] - 1);
	}
}

/*---------------------------------------------------------------------------*/
/*                          Pre-Autonomous Functions                         */
/*                                                                           */
/*  You may want to perform some actions before the competition starts.      */
/*  Do them in the following function.  You must return from this function   */
/*  or the autonomous and usercontrol tasks will not be started.  This       */
/*  function is only called once after the cortex has been powered on and    */
/*  not every time that the robot is disabled.                               */
/*---------------------------------------------------------------------------*/

void pre_auton()
{
  // Set bStopTasksBetweenModes to false if you want to keep user created tasks
  // running between Autonomous and Driver controlled modes. You will need to
  // manage all user created tasks if set to false.
  bStopTasksBetweenModes = true;

	// Set bDisplayCompetitionStatusOnLcd to false if you don't want the LCD
	// used by the competition include file, for example, you might want
	// to display your team name on the LCD in this function.
	bDisplayCompetitionStatusOnLcd = false;

  // All activities that occur before the competition starts
  // Example: clearing encoders, setting servo positions, ...
}

task autonomous()
{
  AutonomousCodePlaceholderForTesting();
}

task usercontrol()
{
  while (true)
  {
    moveStick();
    clawControl();
  }
}
